Bug 911111 - Review Request: php-pecl-zendopcache - The Zend OPcache
Review Request: php-pecl-zendopcache - The Zend OPcache
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
All Linux
medium Severity medium
: ---
: ---
Assigned To: Jared Smith
Fedora Extras Quality Assurance
Depends On:
  Show dependency treegraph
Reported: 2013-02-14 07:20 EST by Remi Collet
Modified: 2013-05-18 05:51 EDT (History)
8 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2013-05-18 05:51:53 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
jsmith.fedora: fedora‑review+
limburgher: fedora‑cvs+
fedora: rhel‑rawhide-

Attachments (Terms of Use)

  None (edit)
Description Remi Collet 2013-02-14 07:20:44 EST
Spec URL: https://raw.github.com/remicollet/remirepo/73a2c97649505cf62cf83db5acc253015c658c0d/php/php-ZendOptimizerPlus/php-ZendOptimizerPlus.spec
SRPM URL: http://rpms.famillecollet.com/SRPMS/php-ZendOptimizerPlus-7.0.0-0.3.gita84b588.remi.src.rpm
The Zend Optimizer+ provides faster PHP execution through opcode caching and
optimization. It improves PHP performance by storing precompiled script
bytecode in the shared memory. This eliminates the stages of reading code from
the disk and compiling it on future access. In addition, it applies a few
bytecode optimization patterns that make code execution faster.

Fedora Account System Username: remi
Comment 1 Remi Collet 2013-02-14 07:25:00 EST
This extension should be part of PHP 5.5 or 5.6.

So this package is only for previous versions (and will very probably obsolete APC in a near future)
Comment 2 Remi Collet 2013-02-15 10:41:22 EST
I prefer to differ a little this review, waiting for merge in php-src (should be before 5.5alpha5, planed for March 7th) to see which will be the extension name, and to avoid a package renaming.
Comment 3 Johan Cwiklinski 2013-02-15 10:44:02 EST
Ok, no problem. Feel free to ping me when that's ok.
Comment 6 Johan Cwiklinski 2013-03-11 02:26:57 EDT
Unfortunately, I will not have time for this review until a few weeks :/

I will unassign myself, if someone would like to take it.
Comment 7 Remi Collet 2013-03-18 09:53:43 EDT
I prefer to switch to latest github snapshot, where the tree is in sync with php-src. The extension have been renamed to "opcache" and is now part of php 5.5.

Spec: https://raw.github.com/remicollet/remirepo/bf8361c187827bf95bd2b29f1c2a4430432f1f51/php/pecl/php-pecl-zendoptimizerplus/php-pecl-zendoptimizerplus.spec

Srpm: http://rpms.famillecollet.com/SRPMS/php-pecl-zendoptimizerplus-7.0.1-0.1.gitcef6093.remi.src.rpm
Comment 8 Remi Collet 2013-03-25 08:01:18 EDT
Upstream project have been renamed to ZendOpcache, so : 

Spec: https://raw.github.com/remicollet/remirepo/a30c5d2d6c7a82ce852245ab2772b31a8b6050da/php/pecl/php-pecl-zendopcache/php-pecl-zendopcache.spec
Srpm: http://rpms.famillecollet.com/SRPMS/php-pecl-zendopcache-7.0.1-1.remi.src.rpm

As PHP 5.5.0 is already imported in Fedora 19, and already provides this extension (php-opcache package), this new package only target F17, F18 and EPEL-6.

I think we have now the final name ;)
Comment 10 Jared Smith 2013-04-16 14:47:26 EDT
[ O K ] MUST: rpmlint must be run on every package. The output should be posted
in the review.

$ rpmlint <spec> <srpm> <rpm>
[jsmith@hockey PackageReview]$ rpmlint php-pecl-zendopcache.spec php-pecl-zendopcache-7.0.1-2.remi.src.rpm /home/jsmith/rpmbuild/RPMS/x86_64/php-pecl-zendopcache-7.0.1-2.fc18.x86_64.rpm 
php-pecl-zendopcache.src: W: spelling-error %description -l en_US opcode -> op code, op-code, code
php-pecl-zendopcache.src: W: spelling-error %description -l en_US precompiled -> recompiled, p recompiled, recompile
php-pecl-zendopcache.src: W: spelling-error %description -l en_US bytecode -> byte code, byte-code, decorate
php-pecl-zendopcache.src: E: unknown-key GPG#00f97f56
php-pecl-zendopcache.x86_64: W: spelling-error %description -l en_US opcode -> op code, op-code, code
php-pecl-zendopcache.x86_64: W: spelling-error %description -l en_US precompiled -> recompiled, p recompiled, recompile
php-pecl-zendopcache.x86_64: W: spelling-error %description -l en_US bytecode -> byte code, byte-code, decorate
2 packages and 1 specfiles checked; 1 errors, 6 warnings.

Notice that the error is about an unknown signing key, and not relevant to the package review.

[ O K ] MUST: The package must be named according to the Package Naming

[ O K ] MUST: The spec file name must match the base package %{name}, in the
format %{name}.spec unless your package has an exemption.

[ O K ] MUST: The package must meet the Packaging Guidelines.

[ O K ] MUST: The package must be licensed with a Fedora approved license and
meet the Licensing Guidelines.

[ O K ] MUST: The License field in the package spec file must match the actual

[ O K ] MUST: If (and only if) the source package includes the text of the
license(s) in its own file, then that file, containing the text of the
license(s) for the package must be included in %doc.

[ O K ] MUST: The spec file must be written in American English. 

[ O K ] MUST: The spec file for the package MUST be legible. 

[ O K ] MUST: The sources used to build the package must match the upstream
source, as provided in the spec URL. Reviewers should use md5sum for this task.
If no upstream URL can be specified for this package, please see the Source URL
Guidelines for how to deal with this.

[jsmith@hockey PackageReview]$ md5sum ~/rpmbuild/SOURCES/zendopcache-7.0.1.tgz ; curl -s -o - http://pecl.php.net/get/zendopcache-7.0.1.tgz | md5sum -
3a0a43a4819c72763bc35ecf5689221e  /home/jsmith/rpmbuild/SOURCES/zendopcache-7.0.1.tgz
3a0a43a4819c72763bc35ecf5689221e  -

[ O K ] MUST: The package MUST successfully compile and build into binary rpms
on at least one primary architecture. 

[ N/A ] MUST: If the package does not successfully compile, build or work on an
architecture, then those architectures should be listed in the spec in
ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in
bugzilla, describing the reason that the package does not compile/build/work on
that architecture. The bug number MUST be placed in a comment, next to the
corresponding ExcludeArch line. 

[ O K ] MUST: All build dependencies must be listed in BuildRequires, except
for any that are listed in the exceptions section of the Packaging Guidelines ;
inclusion of those as BuildRequires is optional. Apply common sense.

[ N/A ] MUST: The spec file MUST handle locales properly. This is done by using
the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.

[ N/A ] MUST: Every binary RPM package (or subpackage) which stores shared
library files (not just symlinks) in any of the dynamic linker's default paths,
must call ldconfig in %post and %postun. 

[ O K ] MUST: Packages must NOT bundle copies of system libraries.

[ N/A ] MUST: If the package is designed to be relocatable, the packager must
state this fact in the request for review, along with the rationalization for
relocation of that specific package. Without this, use of Prefix: /usr is
considered a blocker. 

[ O K ] MUST: A package must own all directories that it creates. If it does
not create a directory that it uses, then it should require a package which
does create that directory. 

[ O K ] MUST: A Fedora package must not list a file more than once in the spec
file's %files listings. (Notable exception: license texts in specific

[ O K ] MUST: Permissions on files must be set properly. Executables should be
set with executable permissions, for example. Every %files section must include
a %defattr(...) line. 

[ O K ] MUST: Each package must consistently use macros. 

[ O K ] MUST: The package must contain code, or permissible content. 

[ O K ] MUST: Large documentation files must go in a -doc subpackage. (The
definition of large is left up to the packager's best judgement, but is not
restricted to size. Large can refer to either size or quantity). 

[ O K ] MUST: If a package includes something as %doc, it must not affect the
runtime of the application. To summarize: If it is in %doc, the program must
run properly if it is not present. 

[ N/A ] MUST: Header files must be in a -devel package. 

[ N/A ] MUST: Static libraries must be in a -static package. 

[ N/A ] MUST: If a package contains library files with a suffix (e.g.
libfoo.so.1.1), then library files that end in .so (without suffix) must go in
a -devel package. 

[ N/A ] MUST: In the vast majority of cases, devel packages must require the
base package using a fully versioned dependency: Requires: %{name} =

[ O K ] MUST: Packages must NOT contain any .la libtool archives, these must be
removed in the spec if they are built.

[ N/A ] MUST: Packages containing GUI applications must include a
%{name}.desktop file, and that file must be properly installed with
desktop-file-install in the %install section. If you feel that your packaged
GUI application does not need a .desktop file, you must put a comment in the
spec file with your explanation. 

[ N/A ] MUST: Packages must not own files or directories already owned by other
packages. The rule of thumb here is that the first package to be installed
should own the files or directories that other packages may rely upon. This
means, for example, that no package in Fedora should ever share ownership with
any of the files or directories owned by the filesystem or man package. If you
feel that you have a good reason to own a file or directory that another
package owns, then please present that at package review time. 

[ O K ] MUST: All filenames in rpm packages must be valid UTF-8.

[ N/A ] SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it. 

[  X  ] SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.
[ O K ] SHOULD: The reviewer should test that the package builds in mock.
[ O K ] SHOULD: The package should compile and build into binary rpms on all supported architectures.
[ O K ] SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
[ N/A ] SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.
[ N/A ] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
[ N/A ] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb.
[ N/A ] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.
[ N/A ] SHOULD: your package should contain man pages for binaries/scripts. If it doesn't, work with upstream to add them where they make sense.

Package is approved.
Comment 11 Remi Collet 2013-04-17 02:55:17 EDT
Great thanks for this review

No F19 branch as this package is f18 and el6 only.

New Package SCM Request
Package Name: php-pecl-zendopcache
Short Description: The Zend OPcache
Owners: remi
Branches: f17 f18 el6
Comment 12 Gwyn Ciesla 2013-04-17 11:17:02 EDT
Git done (by process-git-requests).

Added f19 branch.
Comment 13 Remi Collet 2013-05-18 05:51:53 EDT
Avaiable in F17, F18 and EPEL-6 repository.

Note You need to log in before you can comment on or make changes to this bug.